/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse xbsql_parse
#define yylex   xbsql_lex
#define yyerror xbsql_error
#define yylval  xbsql_lval
#define yychar  xbsql_char
#define yydebug xbsql_debug
#define yynerrs xbsql_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_COMMA = 258,
     T_SELECT = 259,
     T_INSERT = 260,
     T_UPDATE = 261,
     T_DELETE = 262,
     T_CREATE = 263,
     T_DROP = 264,
     T_FROM = 265,
     T_WHERE = 266,
     T_GROUP = 267,
     T_HAVING = 268,
     T_BY = 269,
     T_AND = 270,
     T_OR = 271,
     T_INTO = 272,
     T_VALUES = 273,
     T_SET = 274,
     T_AS = 275,
     T_TABLE = 276,
     T_PLACE = 277,
     T_STRING = 278,
     T_NAME = 279,
     T_NUMBER = 280,
     T_REAL = 281,
     T_PLUS = 282,
     T_MINUS = 283,
     T_MULTIPLY = 284,
     T_DIVIDE = 285,
     T_REM = 286,
     T_EQUALS = 287,
     T_NOTEQUAL = 288,
     T_LT = 289,
     T_LE = 290,
     T_GT = 291,
     T_GE = 292,
     T_CONCAT = 293,
     T_BRA = 294,
     T_KET = 295,
     T_PERIOD = 296,
     T_INTEGER = 297,
     T_FLOAT = 298,
     T_CHAR = 299,
     T_BLOB = 300,
     T_BOOLEAN = 301,
     T_TRUE = 302,
     T_FALSE = 303,
     T_DATE = 304,
     T_UNIQUE = 305,
     T_INDEX = 306,
     T_ORDER = 307,
     T_ASCENDING = 308,
     T_DESCENDING = 309,
     T_NULL = 310,
     T_LIKE = 311,
     T_MIN = 312,
     T_MAX = 313,
     T_SUM = 314,
     T_COUNT = 315,
     T_UPPER = 316,
     T_LOWER = 317,
     T_NULLIF = 318,
     T_TOCHAR = 319
   };
#endif
#define T_COMMA 258
#define T_SELECT 259
#define T_INSERT 260
#define T_UPDATE 261
#define T_DELETE 262
#define T_CREATE 263
#define T_DROP 264
#define T_FROM 265
#define T_WHERE 266
#define T_GROUP 267
#define T_HAVING 268
#define T_BY 269
#define T_AND 270
#define T_OR 271
#define T_INTO 272
#define T_VALUES 273
#define T_SET 274
#define T_AS 275
#define T_TABLE 276
#define T_PLACE 277
#define T_STRING 278
#define T_NAME 279
#define T_NUMBER 280
#define T_REAL 281
#define T_PLUS 282
#define T_MINUS 283
#define T_MULTIPLY 284
#define T_DIVIDE 285
#define T_REM 286
#define T_EQUALS 287
#define T_NOTEQUAL 288
#define T_LT 289
#define T_LE 290
#define T_GT 291
#define T_GE 292
#define T_CONCAT 293
#define T_BRA 294
#define T_KET 295
#define T_PERIOD 296
#define T_INTEGER 297
#define T_FLOAT 298
#define T_CHAR 299
#define T_BLOB 300
#define T_BOOLEAN 301
#define T_TRUE 302
#define T_FALSE 303
#define T_DATE 304
#define T_UNIQUE 305
#define T_INDEX 306
#define T_ORDER 307
#define T_ASCENDING 308
#define T_DESCENDING 309
#define T_NULL 310
#define T_LIKE 311
#define T_MIN 312
#define T_MAX 313
#define T_SUM 314
#define T_COUNT 315
#define T_UPPER 316
#define T_LOWER 317
#define T_NULLIF 318
#define T_TOCHAR 319




/* Copy the first part of user declarations.  */
#line 3 "xbsql.y"

#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#ifdef 		_WIN32
#include 	<io.h>
#endif

#include	"xbsql.h"

extern	void		yyerror	(const char *, ...) ;
extern	int		yylex	()	;
static	void		string	(int)	;
static	int		nextChar()	;
static	int		nextData(char *,  int, int) ;
static	char		*textp		;
static	const char	*qp		;
static	XBaseSQL	*xbXBaseSQL	;
static	int		placeNo		;
static	int		xbLookup(const char *) ;

char	*xbTextb	;

char	*xbStoreText
	(	const char	*text
	)
{
	if (text != 0)
	{
		char	*res	= textp	;
		strcpy	(textp, text)	;
		textp	+= strlen (text)+1;
		return	res	;
	}

	return	0 ;
}

typedef	struct
{
	int		t	;
	int		w	;
	int		p	;
	XBSQL::Index	i	;
}	ColType	;

#undef	getc
#define	getc(f)		nextChar()
#define	fread(b,n,l,f)	nextData(b,n,l)	
#define	orzel_read(f,b,l)	nextData(b,1,l)

XBSQLCommand	*xbQuery	;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 137 "xbsql.y"
typedef union YYSTYPE {
	XBSQLSelect	*sqlsel	;
	XBSQLInsert	*sqlins	;
	XBSQLUpdate	*sqlupd	;
	XBSQLDelete	*sqldel	;
	XBSQLQuery	*query	;
	XBSQLExprList	*elist	;
	XBSQLExprNode	*enode	;
	XBSQLFieldList	*flist	;
	XBSQLAssignList	*alist	;
	XBSQLTableList	*table	;
	XBSQLColumnList	*columns;
	char		*_str	;
	char            _bool   ;
	int		_num	;
	double		_dbl	;
	XBSQL::Index	_idx	;
	ColType		coltype	;
	void		*dummy	;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 289 "xbsql.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 301 "xbsql.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   514

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  30
/* YYNRULES -- Number of rules. */
#define YYNRULES  103
/* YYNRULES -- Number of states. */
#define YYNSTATES  215

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   319

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    24,
      35,    43,    51,    56,    61,    67,    74,    78,    81,    86,
      90,    94,    97,   101,   104,   108,   111,   113,   116,   117,
     123,   127,   128,   131,   132,   134,   138,   142,   143,   146,
     147,   151,   152,   155,   160,   162,   164,   165,   167,   171,
     173,   176,   180,   185,   189,   195,   197,   201,   203,   207,
     211,   217,   219,   223,   227,   233,   235,   237,   239,   241,
     243,   245,   247,   249,   253,   255,   257,   261,   265,   269,
     273,   277,   281,   285,   289,   293,   297,   301,   305,   309,
     313,   317,   321,   326,   331,   336,   341,   346,   351,   356,
     361,   363,   367,   369
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      66,     0,    -1,    67,    -1,    68,    -1,    70,    -1,    69,
      -1,    71,    -1,    72,    -1,     4,    87,    10,    85,    77,
      79,    80,    81,    -1,     5,    17,    24,    39,    84,    40,
      18,    39,    88,    40,    -1,     5,    17,    24,    18,    39,
      88,    40,    -1,     5,    17,    24,    39,    84,    40,    67,
      -1,     5,    17,    24,    67,    -1,     7,    10,    24,    77,
      -1,     6,    24,    19,    86,    77,    -1,     8,    21,    24,
      39,    73,    40,    -1,     9,    21,    24,    -1,    24,    74,
      -1,    24,    74,     3,    73,    -1,    42,    76,    75,    -1,
      43,    76,    75,    -1,    46,    76,    -1,    44,    76,    75,
      -1,    45,    76,    -1,    49,    76,    75,    -1,    49,    76,
      -1,    51,    -1,    50,    51,    -1,    -1,    39,    25,     3,
      25,    40,    -1,    39,    25,    40,    -1,    -1,    11,    78,
      -1,    -1,    89,    -1,    89,    15,    78,    -1,    12,    14,
      94,    -1,    -1,    13,    89,    -1,    -1,    52,    14,    82,
      -1,    -1,    89,    83,    -1,    89,    83,     3,    82,    -1,
      53,    -1,    54,    -1,    -1,    24,    -1,    24,     3,    84,
      -1,    24,    -1,    24,    24,    -1,    24,     3,    85,    -1,
      24,    24,     3,    85,    -1,    24,    32,    89,    -1,    24,
      32,    89,     3,    86,    -1,    29,    -1,    29,     3,    87,
      -1,    89,    -1,    89,    20,    24,    -1,    89,     3,    87,
      -1,    89,    20,    24,     3,    87,    -1,    89,    -1,    89,
      20,    24,    -1,    89,     3,    88,    -1,    89,    20,    24,
       3,    88,    -1,    90,    -1,    91,    -1,    25,    -1,    47,
      -1,    48,    -1,    26,    -1,    23,    -1,    24,    -1,    24,
      41,    24,    -1,    55,    -1,    22,    -1,    39,    89,    40,
      -1,    89,    27,    89,    -1,    89,    28,    89,    -1,    89,
      29,    89,    -1,    89,    30,    89,    -1,    89,    31,    89,
      -1,    89,    38,    89,    -1,    89,    56,    89,    -1,    89,
      32,    89,    -1,    89,    33,    89,    -1,    89,    34,    89,
      -1,    89,    35,    89,    -1,    89,    36,    89,    -1,    89,
      37,    89,    -1,    89,    15,    89,    -1,    89,    16,    89,
      -1,    57,    39,    92,    40,    -1,    58,    39,    92,    40,
      -1,    59,    39,    92,    40,    -1,    61,    39,    92,    40,
      -1,    62,    39,    92,    40,    -1,    64,    39,    92,    40,
      -1,    63,    39,    93,    40,    -1,    60,    39,    29,    40,
      -1,    89,    -1,    89,     3,    92,    -1,    89,    -1,    89,
       3,    94,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   193,   193,   194,   195,   196,   197,   198,   201,   209,
     216,   223,   230,   238,   246,   254,   261,   268,   273,   279,
     287,   295,   303,   311,   319,   327,   336,   341,   346,   351,
     358,   365,   373,   378,   383,   388,   394,   399,   404,   409,
     414,   419,   424,   429,   435,   440,   445,   450,   455,   461,
     466,   471,   476,   482,   487,   493,   498,   503,   508,   513,
     518,   524,   529,   534,   539,   545,   547,   549,   554,   559,
     564,   569,   574,   579,   584,   589,   594,   601,   606,   611,
     616,   621,   626,   631,   636,   641,   646,   651,   656,   661,
     666,   671,   677,   682,   687,   692,   697,   702,   707,   712,
     718,   724,   730,   735
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_COMMA", "T_SELECT", "T_INSERT", 
  "T_UPDATE", "T_DELETE", "T_CREATE", "T_DROP", "T_FROM", "T_WHERE", 
  "T_GROUP", "T_HAVING", "T_BY", "T_AND", "T_OR", "T_INTO", "T_VALUES", 
  "T_SET", "T_AS", "T_TABLE", "T_PLACE", "T_STRING", "T_NAME", "T_NUMBER", 
  "T_REAL", "T_PLUS", "T_MINUS", "T_MULTIPLY", "T_DIVIDE", "T_REM", 
  "T_EQUALS", "T_NOTEQUAL", "T_LT", "T_LE", "T_GT", "T_GE", "T_CONCAT", 
  "T_BRA", "T_KET", "T_PERIOD", "T_INTEGER", "T_FLOAT", "T_CHAR", 
  "T_BLOB", "T_BOOLEAN", "T_TRUE", "T_FALSE", "T_DATE", "T_UNIQUE", 
  "T_INDEX", "T_ORDER", "T_ASCENDING", "T_DESCENDING", "T_NULL", "T_LIKE", 
  "T_MIN", "T_MAX", "T_SUM", "T_COUNT", "T_UPPER", "T_LOWER", "T_NULLIF", 
  "T_TOCHAR", "$accept", "query", "select", "insert", "delete", "update", 
  "create", "drop", "columns", "coltype", "indexed", "colsize", 
  "wherepart", "wherelist", "grouppart", "havingpart", "orderpart", 
  "orderlist", "ascdesc", "fieldlist", "tablelist", "assignlist", 
  "selectlist", "exprlist", "expr", "binaryexpr", "funcexpr", "arglist1", 
  "arglist2", "arglistN", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    65,    66,    66,    66,    66,    66,    66,    67,    68,
      68,    68,    68,    69,    70,    71,    72,    73,    73,    74,
      74,    74,    74,    74,    74,    74,    75,    75,    75,    76,
      76,    76,    77,    77,    78,    78,    79,    79,    80,    80,
      81,    81,    82,    82,    83,    83,    83,    84,    84,    85,
      85,    85,    85,    86,    86,    87,    87,    87,    87,    87,
      87,    88,    88,    88,    88,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    91,    91,    91,    91,    91,    91,    91,    91,
      92,    93,    94,    94
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     8,    10,
       7,     7,     4,     4,     5,     6,     3,     2,     4,     3,
       3,     2,     3,     2,     3,     2,     1,     2,     0,     5,
       3,     0,     2,     0,     1,     3,     3,     0,     2,     0,
       3,     0,     2,     4,     1,     1,     0,     1,     3,     1,
       2,     3,     4,     3,     5,     1,     3,     1,     3,     3,
       5,     1,     3,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     3,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     2,     3,
       5,     4,     6,     7,    75,    71,    72,    67,    70,    55,
       0,    68,    69,    74,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    65,    66,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,    16,    73,    56,    76,   100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
      33,    59,    90,    91,    58,    77,    78,    79,    80,    81,
      84,    85,    86,    87,    88,    89,    82,    83,     0,     0,
      12,     0,    33,     0,    13,     0,    92,    93,    94,    99,
      95,    96,     0,    98,    97,     0,    50,    37,     0,     0,
      47,     0,     0,    14,    32,    34,     0,     0,   101,    51,
       0,     0,    39,    60,     0,    61,     0,     0,    53,     0,
      31,    31,    31,    31,    31,    31,    17,    15,    52,     0,
       0,    41,    10,     0,     0,    48,     0,    11,     0,    35,
      34,     0,    28,    28,    28,    23,    21,    25,     0,   102,
      36,    38,     0,     8,    63,    62,     0,    54,     0,     0,
      26,    19,    20,    22,    24,    18,     0,     0,     0,     0,
       0,    30,    27,   103,    40,    46,    64,     9,     0,    44,
      45,    42,    29,     0,    43
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     7,     8,     9,    10,    11,    12,    13,   137,   156,
     191,   172,   114,   134,   142,   161,   183,   204,   211,   131,
      90,   112,    32,   144,    79,    34,    35,    80,    87,   180
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -147
static const short yypact[] =
{
     159,   261,    -8,    -6,    29,    22,    50,    20,  -147,  -147,
    -147,  -147,  -147,  -147,  -147,  -147,    31,  -147,  -147,    73,
     288,  -147,  -147,  -147,    35,    38,    40,    42,    45,    46,
      51,    52,    82,    67,  -147,  -147,    69,    87,    83,    85,
      94,  -147,    95,   261,   326,   288,   288,   288,    81,   288,
     288,   288,   288,    98,   261,   288,   288,   102,   288,   288,
     288,   288,   288,   288,   288,   288,   288,   288,   288,   288,
     288,    17,   106,   100,    90,  -147,  -147,  -147,  -147,   356,
     104,   114,   115,   117,   120,   140,   171,   141,   143,    10,
     100,  -147,   458,   446,   144,    16,    16,  -147,  -147,  -147,
      86,    86,    86,    86,    86,    86,   142,    86,   145,   121,
    -147,   150,   100,   288,  -147,   122,  -147,  -147,  -147,  -147,
    -147,  -147,   288,  -147,  -147,    98,   185,   177,   261,   288,
     187,   151,   288,  -147,  -147,   386,   107,   152,  -147,  -147,
      98,   179,   181,  -147,   173,   105,   121,    71,   207,   288,
     172,   172,   172,   172,   172,   172,   211,  -147,  -147,   288,
     288,   163,  -147,   288,   192,  -147,   178,  -147,   106,  -147,
     416,   193,   -35,   -35,   -35,  -147,  -147,   -35,   122,   243,
    -147,   356,   205,  -147,  -147,   217,   288,  -147,     4,   170,
    -147,  -147,  -147,  -147,  -147,  -147,   288,   288,   288,   184,
     200,  -147,  -147,  -147,  -147,    -5,  -147,  -147,   186,  -147,
    -147,   225,  -147,   288,  -147
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -147,  -147,   -67,  -147,  -147,  -147,  -147,  -147,    53,  -147,
    -136,    24,   -76,    80,  -147,  -147,  -147,    19,  -147,    84,
     -52,    65,   -42,  -146,    -1,  -147,  -147,   -44,  -147,    54
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -91
static const short yytable[] =
{
      33,    77,    81,    82,   110,    84,    85,   200,    88,    36,
      55,    56,    91,   125,   127,   189,   190,   184,    37,    44,
      41,     1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,   126,   108,   133,   192,   193,    38,
     199,   194,    33,    39,   201,    60,    61,    62,   209,   210,
      86,    70,   206,    33,    92,    93,   109,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      54,    40,    42,   139,    45,     1,    43,    46,   138,    47,
     167,    48,    55,    56,    49,    50,   143,    57,   158,   166,
      51,    52,    53,    71,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    72,    73,   163,    74,
      83,   113,   135,    58,    59,    60,    61,    62,    75,    76,
      55,    56,    89,    70,    69,   164,    94,    33,   145,   115,
     111,   148,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,   116,   130,   136,   128,   170,   150,
     151,   152,   153,   154,   117,   118,   155,   119,   179,   181,
     120,    70,   145,     1,     2,     3,     4,     5,     6,    58,
      59,    60,    61,    62,   122,   173,   174,   175,   176,   177,
     121,   123,   132,   124,   129,   145,    55,    56,   140,   141,
     146,   147,   157,   159,   160,   179,   205,   145,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
     168,   171,   205,   162,   178,   182,   185,   186,   188,   197,
     198,   202,    55,    56,   207,   208,   212,    70,   213,   169,
     165,   195,   214,   187,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,   196,     0,     0,     0,
     203,     0,     0,     0,     0,     0,     0,     0,    55,    56,
       0,     0,     0,    70,     0,     0,     0,     0,     0,     0,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,     0,    14,    15,    16,    17,    18,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,    70,
      20,     0,     0,     0,     0,     0,     0,     0,    21,    22,
      14,    15,    16,    17,    18,     0,    23,     0,    24,    25,
      26,    27,    28,    29,    30,    31,     0,    20,     0,     0,
       0,     0,     0,     0,     0,    21,    22,     0,     0,     0,
       0,    55,    56,    23,     0,    24,    25,    26,    27,    28,
      29,    30,    31,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,     0,    78,     0,     0,     0,
       0,    55,    56,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    70,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,     0,     0,     0,     0,     0,
       0,   149,    56,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    70,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,     0,     0,     0,     0,     0,
       0,   -90,   -90,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    70,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,     0,     0,     0,     0,     0,
       0,    55,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    70,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,     0,     0,     0,
       0,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    70
};

static const short yycheck[] =
{
       1,    43,    46,    47,    71,    49,    50,     3,    52,    17,
      15,    16,    54,     3,    90,    50,    51,   163,    24,    20,
       0,     4,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    24,    18,   112,   173,   174,    10,
     186,   177,    43,    21,    40,    29,    30,    31,    53,    54,
      51,    56,   198,    54,    55,    56,    39,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
       3,    21,    41,   125,    39,     4,     3,    39,   122,    39,
     147,    39,    15,    16,    39,    39,   128,    20,   140,    18,
      39,    39,    10,    24,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    19,    24,     3,    24,
      29,    11,   113,    27,    28,    29,    30,    31,    24,    24,
      15,    16,    24,    56,    38,    20,    24,   128,   129,    39,
      24,   132,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    40,    24,    24,     3,   149,    42,
      43,    44,    45,    46,    40,    40,    49,    40,   159,   160,
      40,    56,   163,     4,     5,     6,     7,     8,     9,    27,
      28,    29,    30,    31,     3,   151,   152,   153,   154,   155,
      40,    40,    32,    40,    39,   186,    15,    16,     3,    12,
       3,    40,    40,    14,    13,   196,   197,   198,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
       3,    39,   213,    40,     3,    52,    24,    39,    25,    14,
       3,    51,    15,    16,    40,    25,    40,    56,     3,   149,
     146,   178,   213,   168,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,     3,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    22,    23,    24,    25,    26,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,
      22,    23,    24,    25,    26,    -1,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    48,    -1,    -1,    -1,
      -1,    15,    16,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    56
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,     5,     6,     7,     8,     9,    66,    67,    68,
      69,    70,    71,    72,    22,    23,    24,    25,    26,    29,
      39,    47,    48,    55,    57,    58,    59,    60,    61,    62,
      63,    64,    87,    89,    90,    91,    17,    24,    10,    21,
      21,     0,    41,     3,    89,    39,    39,    39,    39,    39,
      39,    39,    39,    10,     3,    15,    16,    20,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      56,    24,    19,    24,    24,    24,    24,    87,    40,    89,
      92,    92,    92,    29,    92,    92,    89,    93,    92,    24,
      85,    87,    89,    89,    24,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    18,    39,
      67,    24,    86,    11,    77,    39,    40,    40,    40,    40,
      40,    40,     3,    40,    40,     3,    24,    77,     3,    39,
      24,    84,    32,    77,    78,    89,    24,    73,    92,    85,
       3,    12,    79,    87,    88,    89,     3,    40,    89,    15,
      42,    43,    44,    45,    46,    49,    74,    40,    85,    14,
      13,    80,    40,     3,    20,    84,    18,    67,     3,    78,
      89,    39,    76,    76,    76,    76,    76,    76,     3,    89,
      94,    89,    52,    81,    88,    24,    39,    86,    25,    50,
      51,    75,    75,    75,    75,    73,     3,    14,     3,    88,
       3,    40,    51,    94,    82,    89,    88,    40,    25,    53,
      54,    83,    40,     3,    82
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 193 "xbsql.y"
    { yyval.query = yyvsp[0].sqlsel ; ;}
    break;

  case 3:
#line 194 "xbsql.y"
    { yyval.query = yyvsp[0].sqlins ; ;}
    break;

  case 4:
#line 195 "xbsql.y"
    { yyval.query = yyvsp[0].sqlupd ; ;}
    break;

  case 5:
#line 196 "xbsql.y"
    { yyval.query = yyvsp[0].sqldel ; ;}
    break;

  case 6:
#line 197 "xbsql.y"
    { yyval.query = yyvsp[0].query ; ;}
    break;

  case 8:
#line 202 "xbsql.y"
    {
			XBSQLSelect *s = new XBSQLSelect (xbXBaseSQL, yyvsp[-6].elist, yyvsp[-4].table, yyvsp[-3].elist, yyvsp[-2].elist, yyvsp[-1].elist, yyvsp[0].elist) ;
			xbQuery = s ;
			yyval.sqlsel	= s ;
		;}
    break;

  case 9:
#line 210 "xbsql.y"
    {
			XBSQLInsert *i = new XBSQLInsert (xbXBaseSQL, yyvsp[-7]._str, yyvsp[-5].flist, yyvsp[-1].elist) ;
			xbQuery = i ;
			yyval.sqlins	= i ;
		;}
    break;

  case 10:
#line 217 "xbsql.y"
    {
			XBSQLInsert *i = new XBSQLInsert (xbXBaseSQL, yyvsp[-4]._str, 0,  yyvsp[-1].elist) ;
			xbQuery = i ;
			yyval.sqlins	= i ;
		;}
    break;

  case 11:
#line 224 "xbsql.y"
    {
			XBSQLInsert *i = new XBSQLInsert (xbXBaseSQL, yyvsp[-4]._str, yyvsp[-2].flist, yyvsp[0].sqlsel) ;
			xbQuery = i ;
			yyval.sqlins	= i ;
		;}
    break;

  case 12:
#line 231 "xbsql.y"
    {
			XBSQLInsert *i = new XBSQLInsert (xbXBaseSQL, yyvsp[-1]._str, 0,  yyvsp[0].sqlsel) ;
			xbQuery = i ;
			yyval.sqlins	= i ;
		;}
    break;

  case 13:
#line 239 "xbsql.y"
    {
			XBSQLDelete *d = new XBSQLDelete (xbXBaseSQL, yyvsp[-1]._str, yyvsp[0].elist) ;
			xbQuery = d ;
			yyval.sqldel	= d ;
		;}
    break;

  case 14:
#line 247 "xbsql.y"
    {
			XBSQLUpdate *u = new XBSQLUpdate (xbXBaseSQL, yyvsp[-3]._str, yyvsp[-1].alist, yyvsp[0].elist) ;
			xbQuery = u ;
			yyval.sqlupd	= u ;
		;}
    break;

  case 15:
#line 255 "xbsql.y"
    {
			xbQuery	= new XBSQLCreate (xbXBaseSQL, yyvsp[-3]._str, yyvsp[-1].columns) ;
			yyval.query	= 0 ;
		;}
    break;

  case 16:
#line 262 "xbsql.y"
    {
			xbQuery	= new XBSQLDrop   (xbXBaseSQL, yyvsp[0]._str) ;
			yyval.query	= 0 ;
		;}
    break;

  case 17:
#line 269 "xbsql.y"
    {
			yyval.columns	= new XBSQLColumnList (yyvsp[-1]._str, yyvsp[0].coltype.t, yyvsp[0].coltype.w, yyvsp[0].coltype.p, yyvsp[0].coltype.i,  0) ;
		;}
    break;

  case 18:
#line 274 "xbsql.y"
    {
			yyval.columns	= new XBSQLColumnList (yyvsp[-3]._str, yyvsp[-2].coltype.t, yyvsp[-2].coltype.w, yyvsp[-2].coltype.p, yyvsp[-2].coltype.i, yyvsp[0].columns) ;
		;}
    break;

  case 19:
#line 280 "xbsql.y"
    {
			yyval.coltype.t	= 'N' 	;
			yyval.coltype.w	= yyvsp[-1].coltype.w	;
			yyval.coltype.p	= yyvsp[-1].coltype.p	;
			yyval.coltype.i	= yyvsp[0]._idx	;
		;}
    break;

  case 20:
#line 288 "xbsql.y"
    {
			yyval.coltype.t	= 'F' 	;
			yyval.coltype.w	= yyvsp[-1].coltype.w	;
			yyval.coltype.p	= yyvsp[-1].coltype.p	;
			yyval.coltype.i	= yyvsp[0]._idx	;
		;}
    break;

  case 21:
#line 296 "xbsql.y"
    {
			yyval.coltype.t	= 'L' 	;
			yyval.coltype.w	= 1	;
			yyval.coltype.p	= 0	;
			yyval.coltype.i	= XBSQL::IndexNone	;
		;}
    break;

  case 22:
#line 304 "xbsql.y"
    {
			yyval.coltype.t	= 'C' 	;
			yyval.coltype.w	= yyvsp[-1].coltype.w	;
			yyval.coltype.p	= yyvsp[-1].coltype.p	;
			yyval.coltype.i	= yyvsp[0]._idx	;
		;}
    break;

  case 23:
#line 312 "xbsql.y"
    {
			yyval.coltype.t	= 'M' 	;
			yyval.coltype.w	= 10	;
			yyval.coltype.p	= 0	;
			yyval.coltype.i	= XBSQL::IndexNone ;
		;}
    break;

  case 24:
#line 320 "xbsql.y"
    {
			yyval.coltype.t	= 'D' 	;
			yyval.coltype.w	= yyvsp[-1].coltype.w	;
			yyval.coltype.p	= yyvsp[-1].coltype.p	;
			yyval.coltype.i	= yyvsp[0]._idx	;
		;}
    break;

  case 25:
#line 328 "xbsql.y"
    {
			yyval.coltype.t	= 'D' 	;
			yyval.coltype.w	= yyvsp[0].coltype.w	== 0 ? 8 : yyvsp[0].coltype.w ;
			yyval.coltype.p	= yyvsp[0].coltype.p	;
			yyval.coltype.i	= XBSQL::IndexNone	;
		;}
    break;

  case 26:
#line 337 "xbsql.y"
    {
			yyval._idx	= XBSQL::IndexNotUnique	;
		;}
    break;

  case 27:
#line 342 "xbsql.y"
    {
			yyval._idx	= XBSQL::IndexUnique	;
		;}
    break;

  case 28:
#line 346 "xbsql.y"
    {
			yyval._idx	= XBSQL::IndexNone	;
		;}
    break;

  case 29:
#line 352 "xbsql.y"
    {
			yyval.coltype.t	= 0	;
			yyval.coltype.w	= yyvsp[-3]._num	;
			yyval.coltype.p	= yyvsp[-1]._num	;
		;}
    break;

  case 30:
#line 359 "xbsql.y"
    {
			yyval.coltype.t	= 0	;
			yyval.coltype.w	= yyvsp[-1]._num	;
			yyval.coltype.p	= 0	;
		;}
    break;

  case 31:
#line 365 "xbsql.y"
    {
			yyval.coltype.t	= 0	;
			yyval.coltype.w	= 0	;
			yyval.coltype.p	= 0	;
		;}
    break;

  case 32:
#line 374 "xbsql.y"
    {
			yyval.elist = yyvsp[0].elist ;
		;}
    break;

  case 33:
#line 378 "xbsql.y"
    {
			yyval.elist =  0 ;
		;}
    break;

  case 34:
#line 384 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0, 0) ;
		;}
    break;

  case 35:
#line 389 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;

  case 36:
#line 395 "xbsql.y"
    {
			yyval.elist = yyvsp[0].elist ;
		;}
    break;

  case 37:
#line 399 "xbsql.y"
    {
			yyval.elist =  0 ;
		;}
    break;

  case 38:
#line 405 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0,  0) ;
		;}
    break;

  case 39:
#line 409 "xbsql.y"
    {
			yyval.elist =  0 ;
		;}
    break;

  case 40:
#line 415 "xbsql.y"
    {
			yyval.elist = yyvsp[0].elist ;
		;}
    break;

  case 41:
#line 419 "xbsql.y"
    {
			yyval.elist =  0 ;
		;}
    break;

  case 42:
#line 425 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-1].enode, yyvsp[0]._num,  0) ;
		;}
    break;

  case 43:
#line 430 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-3].enode, yyvsp[-2]._num, yyvsp[0].elist) ;
		;}
    break;

  case 44:
#line 436 "xbsql.y"
    {
			yyval._num = 1 ;
		;}
    break;

  case 45:
#line 441 "xbsql.y"
    {
			yyval._num = 0 ;
		;}
    break;

  case 46:
#line 445 "xbsql.y"
    {
			yyval._num = 1 ;
		;}
    break;

  case 47:
#line 451 "xbsql.y"
    {
			yyval.flist = new XBSQLFieldList (yyvsp[0]._str,  0) ;
		;}
    break;

  case 48:
#line 456 "xbsql.y"
    {
			yyval.flist = new XBSQLFieldList (yyvsp[-2]._str, yyvsp[0].flist) ;
		;}
    break;

  case 49:
#line 462 "xbsql.y"
    {
			yyval.table = new XBSQLTableList (yyvsp[0]._str, 0,  0) ;
		;}
    break;

  case 50:
#line 467 "xbsql.y"
    {
			yyval.table = new XBSQLTableList (yyvsp[-1]._str, yyvsp[0]._str, 0) ;
		;}
    break;

  case 51:
#line 472 "xbsql.y"
    {
			yyval.table = new XBSQLTableList (yyvsp[-2]._str, 0, yyvsp[0].table) ;
		;}
    break;

  case 52:
#line 477 "xbsql.y"
    {
			yyval.table = new XBSQLTableList (yyvsp[-3]._str, yyvsp[-2]._str, yyvsp[0].table) ;
		;}
    break;

  case 53:
#line 483 "xbsql.y"
    {
			yyval.alist = new XBSQLAssignList (yyvsp[-2]._str, yyvsp[0].enode,  0) ;
		;}
    break;

  case 54:
#line 488 "xbsql.y"
    {
			yyval.alist = new XBSQLAssignList (yyvsp[-4]._str, yyvsp[-2].enode, yyvsp[0].alist) ;
		;}
    break;

  case 55:
#line 494 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList ( 0,  (const char *)0, 0) ;
		;}
    break;

  case 56:
#line 499 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList ( 0,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;

  case 57:
#line 504 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0, 0) ;
		;}
    break;

  case 58:
#line 509 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  yyvsp[0]._str, 0) ;
		;}
    break;

  case 59:
#line 514 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;

  case 60:
#line 519 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-4].enode,  yyvsp[-2]._str, yyvsp[0].elist) ;
		;}
    break;

  case 61:
#line 525 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0, 0) ;
		;}
    break;

  case 62:
#line 530 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  yyvsp[0]._str, 0) ;
		;}
    break;

  case 63:
#line 535 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;

  case 64:
#line 540 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-4].enode,  yyvsp[-2]._str, yyvsp[0].elist) ;
		;}
    break;

  case 67:
#line 550 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[0]._num, XBSQL::ENumber) ;
		;}
    break;

  case 68:
#line 555 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (1, XBSQL::ENumber) ;
		;}
    break;

  case 69:
#line 560 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (0, XBSQL::ENumber) ;
		;}
    break;

  case 70:
#line 565 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[0]._dbl, XBSQL::EDouble) ;
		;}
    break;

  case 71:
#line 570 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[0]._str, true ) ;
		;}
    break;

  case 72:
#line 575 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[0]._str, false) ;
		;}
    break;

  case 73:
#line 580 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[0]._str, yyvsp[-2]._str, false) ;
		;}
    break;

  case 74:
#line 585 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode ("", true ) ;
		;}
    break;

  case 75:
#line 590 "xbsql.y"
    {	yyval.enode = new XBSQLExprNode (placeNo, XBSQL::EPlace) ;
			placeNo += 1 ;
		;}
    break;

  case 76:
#line 595 "xbsql.y"
    {
			yyval.enode = yyvsp[-1].enode ;
		;}
    break;

  case 77:
#line 602 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EPlus) ;
		;}
    break;

  case 78:
#line 607 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EMinus) ;
		;}
    break;

  case 79:
#line 612 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EMultiply) ;
		;}
    break;

  case 80:
#line 617 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EDivide) ;
		;}
    break;

  case 81:
#line 622 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::ERem) ;
		;}
    break;

  case 82:
#line 627 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EConcat) ;
		;}
    break;

  case 83:
#line 632 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::ELike  ) ;
		;}
    break;

  case 84:
#line 637 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EEquals) ;
		;}
    break;

  case 85:
#line 642 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::ENotEqual) ;
		;}
    break;

  case 86:
#line 647 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::ELT	) ;
		;}
    break;

  case 87:
#line 652 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::ELTEqual	) ;
		;}
    break;

  case 88:
#line 657 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EGT	) ;
		;}
    break;

  case 89:
#line 662 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EGTEqual	) ;
		;}
    break;

  case 90:
#line 667 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EAnd	) ;
		;}
    break;

  case 91:
#line 672 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-2].enode, yyvsp[0].enode, XBSQL::EOr	) ;
		;}
    break;

  case 92:
#line 678 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNMin	) ;
		;}
    break;

  case 93:
#line 683 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNMax	) ;
		;}
    break;

  case 94:
#line 688 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNSum	) ;
		;}
    break;

  case 95:
#line 693 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNUpper	) ;
		;}
    break;

  case 96:
#line 698 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNLower	) ;
		;}
    break;

  case 97:
#line 703 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNToChar	) ;
		;}
    break;

  case 98:
#line 708 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (yyvsp[-1].elist, XBSQL::EFNNullIF	) ;
		;}
    break;

  case 99:
#line 713 "xbsql.y"
    {
			yyval.enode = new XBSQLExprNode (0,  XBSQL::EFNCount	) ;
		;}
    break;

  case 100:
#line 719 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0,  0) ;
		;}
    break;

  case 101:
#line 725 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;

  case 102:
#line 731 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[0].enode,  (const char *)0,  0) ;
		;}
    break;

  case 103:
#line 736 "xbsql.y"
    {
			yyval.elist = new XBSQLExprList (yyvsp[-2].enode,  (const char *)0, yyvsp[0].elist) ;
		;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2159 "xbsql.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 740 "xbsql.y"


#include	"lex.yy.c"


